diff -2rcN /usr/goinfre/gcc-2.7.0/cpplib.c gcc-2.7.0-amiga/cpplib.c
*** /usr/goinfre/gcc-2.7.0/cpplib.c	Thu Jun 15 12:24:38 1995
--- gcc-2.7.0-amiga/cpplib.c	Fri Jun 23 11:52:24 1995
***************
*** 152,155 ****
--- 152,159 ----
  static char *predefs = "";
  #endif
+ 
+ #ifdef __amigados__
+ static int amigados_abs_filename ();
+ #endif
  
  /* We let tm.h override the types used here, to handle trivial differences
***************
*** 3304,3308 ****
--- 3308,3317 ----
    /* If specified file name is absolute, just open it.  */
  
+ /* Phil.B 10-Apr-95 check for absolute filenames */
+ #ifdef __amigados__
+   if (amigados_abs_filename (fbeg, flen)) {
+ #else
    if (*fbeg == '/') {
+ #endif
      strncpy (fname, fbeg, flen);
      fname[flen] = 0;
***************
*** 3327,3330 ****
--- 3336,3343 ----
  	  continue;
  	strcpy (fname, searchptr->fname);
+ /* Phil.B 10-Arp-95 Avoir foo:/ situations */
+ #ifdef __amigados__
+ 	if (fname[strlen (fname) - 1] != ':')
+ #endif
  	strcat (fname, "/");
  	fname[strlen (fname) + flen] = 0;
***************
*** 3400,3403 ****
--- 3413,3420 ----
  					   + strlen (fname) + 2);
  		      strcpy (p, searchptr->fname);
+ /* Phil.B 10-Arp-95 Avoir foo:/ situations */
+ #ifdef __amigados__
+ 	              if (p[strlen (p) - 1] != ':')
+ #endif
  		      strcat (p, "/");
  		      strcat (p, fname);
***************
*** 7511,7514 ****
--- 7528,7554 ----
  }
  
+ #ifdef __amigados__
+ 
+ /* This function returns whether the LEN characters long filename FNAME 
+    is an absolute path specification. */
+ 
+ static int
+ amigados_abs_filename (fname, len)
+      char *fname;
+      int len;
+ {
+   /* we're using ixemul.library, which treats `/foo' as `foo:', so 
+      fname[0] is to be considered absolute as well */
+   if (fname[0] == '/')
+     return 1;
+ 
+   /* else do an index() on fname, but one which is limited to len characters */
+   while (*fname && *fname != ':' && len) 
+     fname++, len--;
+ 
+   return *fname == ':';
+ }
+ #endif /* __amigados__ */
+ 
  /* TODO:
   * No pre-compiled header file support.
diff -2rcN /usr/goinfre/gcc-2.7.0/cpplib.h gcc-2.7.0-amiga/cpplib.h
*** /usr/goinfre/gcc-2.7.0/cpplib.h	Thu Jun 15 12:25:11 1995
--- gcc-2.7.0-amiga/cpplib.h	Fri Jun 23 11:52:25 1995
***************
*** 316,319 ****
--- 316,324 ----
    char verbose;
  
+ /* Phil.B 10-Apr-95 handle amiga process priority */
+ #ifdef __amigados__
+   int amiga_priority;
+ #endif /* __amigados__ */
+ 
    /* Nonzero means use extra default include directories for C++.  */
  
diff -2rcN /usr/goinfre/gcc-2.7.0/cppmain.c gcc-2.7.0-amiga/cppmain.c
*** /usr/goinfre/gcc-2.7.0/cppmain.c	Thu Jun 15 12:25:35 1995
--- gcc-2.7.0-amiga/cppmain.c	Fri Jun 23 11:52:25 1995
***************
*** 33,36 ****
--- 33,41 ----
  cpp_options options;
  
+ #ifdef __amigados__
+ #include <proto/exec.h>
+ struct Task *amiga_task;
+ #endif /* __amigados__ */
+ 
  /* More 'friendly' abort that prints the line and file.
     config.h can #define abort fancy_abort if you like that sort of thing.  */
***************
*** 53,56 ****
--- 58,70 ----
    struct cpp_options *opts = &options;
  
+ #ifdef __amigados__
+   {
+     char *envstr;
+ 
+     if (envstr = getenv("GCCPRIORITY"))
+       if (((i = atoi(envstr)) > -20) && (i < 20)) opts->amiga_priority = i;
+   }
+ #endif /* __amigados__ */
+ 
    p = argv[0] + strlen (argv[0]);
    while (p != argv[0] && p[-1] != '/') --p;
***************
*** 67,70 ****
--- 81,91 ----
    parse_in.show_column = 1;
  
+ #ifdef __amigados__
+   Forbid();
+   amiga_task = FindTask(NULL);
+   Permit();
+   SetTaskPri(amiga_task, opts->amiga_priority);
+ #endif /* __amigados__ */
+ 
    i = push_parse_file (&parse_in, opts->in_fname);
    if (i != SUCCESS_EXIT_CODE)
diff -2rcN /usr/goinfre/gcc-2.7.0/explow.c gcc-2.7.0-amiga/explow.c
*** /usr/goinfre/gcc-2.7.0/explow.c	Thu Jun 15 12:30:10 1995
--- gcc-2.7.0-amiga/explow.c	Fri Jun 23 11:52:26 1995
***************
*** 31,34 ****
--- 31,35 ----
  #include "insn-codes.h"
  
+ rtx gen_stack_cleanup_call();
  static rtx break_out_memory_refs	PROTO((rtx));
  
***************
*** 1096,1099 ****
--- 1097,1109 ----
      }
    else
+ #endif
+ #if 1 /* HAVE_stack_on_heap */
+   if (TARGET_STACKCHECK)
+     emit_insn (gen_stack_management_call
+                 (stack_pointer_rtx, size, "jbsr ___stkchk_d0"));
+   if (TARGET_STACKEXTEND)
+     emit_insn (gen_stack_management_call 
+                 (stack_pointer_rtx, size, "jbsr ___sub_d0_sp"));
+   else
  #endif
      {
diff -2rcN /usr/goinfre/gcc-2.7.0/final.c gcc-2.7.0-amiga/final.c
*** /usr/goinfre/gcc-2.7.0/final.c	Thu Jun 15 12:32:51 1995
--- gcc-2.7.0-amiga/final.c	Fri Jun 23 11:52:26 1995
***************
*** 2039,2042 ****
--- 2039,2046 ----
    if (write_symbols != NO_DEBUG)
      {
+ /* Phil.B: 03-Oct-94 added q_anote from albaugh@agames.com (Mike Albaugh) */
+ #if defined(__amigados__) && defined(ASM_NOTE_SOURCE_LINE)
+   ASM_NOTE_SOURCE_LINE(file,last_linenum,filename);
+ #endif
  #ifdef SDB_DEBUGGING_INFO
        if (write_symbols == SDB_DEBUG
diff -2rcN /usr/goinfre/gcc-2.7.0/fixincludes gcc-2.7.0-amiga/fixincludes
*** /usr/goinfre/gcc-2.7.0/fixincludes	Sun Jun 11 18:37:31 1995
--- gcc-2.7.0-amiga/fixincludes	Fri Jun 23 11:52:27 1995
***************
*** 58,61 ****
--- 58,64 ----
    LINKS=false
  fi
+ # AmigaDOS hack - we have symbolic links, but it's generally
+ # better to not depend on them working correctly.
+ LINKS=false
  
  echo Finding directories and links to directories
diff -2rcN /usr/goinfre/gcc-2.7.0/gcc.c gcc-2.7.0-amiga/gcc.c
*** /usr/goinfre/gcc-2.7.0/gcc.c	Thu Jun 15 12:38:02 1995
--- gcc-2.7.0-amiga/gcc.c	Fri Jun 23 11:52:28 1995
***************
*** 225,228 ****
--- 225,235 ----
  static int save_temps_flag;
  
+ #ifdef __amigados__
+ /* Phil.B: 03-Oct-94 Flag indicating process priority */
+ static int amiga_priority = 0;
+ /* Phil.B: 17-Apr-95 Flag indicating stack checking */
+ static int amiga_stackcheck = 0;
+ #endif /* __amigados__ */
+ 
  /* The compiler version.  */
  
***************
*** 817,820 ****
--- 824,831 ----
     {"--pipe", "-pipe", 0},
     {"--prefix", "-B", "a"},
+ /* Phil.B: 03-Oct-94, allow priority settings for all programs started by gcc */
+ #ifdef __amigados__
+    {"--priority", "-priority", "a"},
+ #endif /* __amigados__ */
     {"--preprocess", "-E", 0},
     {"--print-search-dirs", "-print-search-dirs", 0},
***************
*** 1348,1356 ****
  
  #ifndef STANDARD_EXEC_PREFIX
! #define STANDARD_EXEC_PREFIX "/usr/local/lib/gcc-lib/"
  #endif /* !defined STANDARD_EXEC_PREFIX */
  
  static char *standard_exec_prefix = STANDARD_EXEC_PREFIX;
! static char *standard_exec_prefix_1 = "/usr/lib/gcc/";
  #ifdef MD_EXEC_PREFIX
  static char *md_exec_prefix = MD_EXEC_PREFIX;
--- 1359,1367 ----
  
  #ifndef STANDARD_EXEC_PREFIX
! #define STANDARD_EXEC_PREFIX "/gnu/lib/gcc-lib/"
  #endif /* !defined STANDARD_EXEC_PREFIX */
  
  static char *standard_exec_prefix = STANDARD_EXEC_PREFIX;
! static char *standard_exec_prefix_1 = "/local/lib/gcc-lib/";
  #ifdef MD_EXEC_PREFIX
  static char *md_exec_prefix = MD_EXEC_PREFIX;
***************
*** 1358,1362 ****
  
  #ifndef STANDARD_STARTFILE_PREFIX
! #define STANDARD_STARTFILE_PREFIX "/usr/local/lib/"
  #endif /* !defined STANDARD_STARTFILE_PREFIX */
  
--- 1369,1373 ----
  
  #ifndef STANDARD_STARTFILE_PREFIX
! #define STANDARD_STARTFILE_PREFIX "/gnu/lib/"
  #endif /* !defined STANDARD_STARTFILE_PREFIX */
  
***************
*** 1368,1376 ****
  #endif
  static char *standard_startfile_prefix = STANDARD_STARTFILE_PREFIX;
! static char *standard_startfile_prefix_1 = "/lib/";
! static char *standard_startfile_prefix_2 = "/usr/lib/";
  
  #ifndef TOOLDIR_BASE_PREFIX
! #define TOOLDIR_BASE_PREFIX "/usr/local/"
  #endif
  static char *tooldir_base_prefix = TOOLDIR_BASE_PREFIX;
--- 1379,1387 ----
  #endif
  static char *standard_startfile_prefix = STANDARD_STARTFILE_PREFIX;
! static char *standard_startfile_prefix_1 = "/local/lib/";
! static char *standard_startfile_prefix_2 = "/local/lib/";
  
  #ifndef TOOLDIR_BASE_PREFIX
! #define TOOLDIR_BASE_PREFIX "/local/"
  #endif
  static char *tooldir_base_prefix = TOOLDIR_BASE_PREFIX;
***************
*** 1573,1576 ****
--- 1584,1591 ----
  #endif
  
+ #ifdef __amigados__
+   if (!base) /* No env var set */
+     base = "RAM:";
+ #else
    base = choose_temp_base_try (concat4 (dir_separator_str, "usr", 
                                          dir_separator_str, "tmp"), 
***************
*** 1578,1581 ****
--- 1593,1598 ----
    base = choose_temp_base_try (concat (dir_separator_str, "tmp"), base);
   
+ #endif
+ 
    /* If all else fails, use the current directory! */  
    if (base == (char *)0) base = concat(".", dir_separator_str);
***************
*** 1586,1590 ****
    strcpy (temp_filename, base);
    if (len > 0 && temp_filename[len-1] != '/'
!       && temp_filename[len-1] != DIR_SEPARATOR)
      temp_filename[len++] = DIR_SEPARATOR;
    strcpy (temp_filename + len, "ccXXXXXX");
--- 1603,1611 ----
    strcpy (temp_filename, base);
    if (len > 0 && temp_filename[len-1] != '/'
!       && temp_filename[len-1] != DIR_SEPARATOR
! #ifdef VOL_SEPARATOR
!       && temp_filename[len-1] != VOL_SEPARATOR
! #endif
! 	)
      temp_filename[len++] = DIR_SEPARATOR;
    strcpy (temp_filename + len, "ccXXXXXX");
***************
*** 1747,1751 ****
    /* Determine the filename to execute (special case for absolute paths).  */
  
!   if (*name == '/' || *name == DIR_SEPARATOR)
      {
        if (access (name, mode))
--- 1768,1776 ----
    /* Determine the filename to execute (special case for absolute paths).  */
  
!   if (*name == '/' || *name == DIR_SEPARATOR
! #ifdef VOL_SEPARATOR
!       || index (name, VOL_SEPARATOR)
! #endif
! 	)
      {
        if (access (name, mode))
***************
*** 1967,1970 ****
--- 1992,1996 ----
     (i.e. its output should be piped to the next one.)  */
  
+ #ifndef PEXECUTE
  #ifdef __MSDOS__
  
***************
*** 2171,2174 ****
--- 2197,2201 ----
  }
  #endif /* OS2 or _WIN32 */
+ #endif /* !defined (PEXECUTE) */
  
  
***************
*** 2266,2272 ****
--- 2293,2305 ----
        char *string = commands[i].argv[0];
  
+ #ifdef PEXECUTE
+       commands[i].pid = PEXECUTE (string != commands[i].prog,
+ 				  string, commands[i].argv,
+ 				  i + 1 < n_commands);
+ #else
        commands[i].pid = pexecute (string != commands[i].prog,
  				  string, commands[i].argv,
  				  i + 1 < n_commands);
+ #endif
  
        if (string != commands[i].prog)
***************
*** 2291,2294 ****
--- 2324,2330 ----
  	int pid;
  
+ #ifdef PEXECUTE_RESULT
+ 	pid = PEXECUTE_RESULT (status, commands[i]);
+ #else /* PEXECUTE_RESULT */
  #ifdef __MSDOS__
          status = pid = commands[i].pid;
***************
*** 2300,2303 ****
--- 2336,2340 ----
  #endif
  #endif
+ #endif /* PEXECUTE_RESULT */
  	if (pid < 0)
  	  abort ();
***************
*** 2419,2422 ****
--- 2456,2460 ----
  	    {
  	      strncpy (nstore, startp, endp-startp);
+ #ifndef __amigados__
  	      if (endp == startp)
  		strcpy (nstore, concat (".", dir_separator_str));
***************
*** 2428,2431 ****
--- 2466,2478 ----
  	      else
  		nstore[endp-startp] = 0;
+ #else
+ 	      if (endp[-1] != '/' && endp[-1] != ':')
+ 		{
+ 		  nstore[endp-startp] = '/';
+ 		  nstore[endp-startp+1] = 0;
+ 		}
+ 	      else
+ 		nstore[endp-startp] = 0;
+ #endif
  	      add_prefix (&exec_prefixes, nstore, 0, 0, NULL_PTR);
  	      if (*endp == 0)
***************
*** 2450,2453 ****
--- 2497,2501 ----
  	    {
  	      strncpy (nstore, startp, endp-startp);
+ #ifndef __amigados__
  	      if (endp == startp)
  		strcpy (nstore, concat (".", dir_separator_str));
***************
*** 2459,2462 ****
--- 2507,2519 ----
  	      else
  		nstore[endp-startp] = 0;
+ #else
+ 	      if (endp[-1] != '/' && endp[-1] != ':')
+ 		{
+ 		  nstore[endp-startp] = '/';
+ 		  nstore[endp-startp+1] = 0;
+ 		}
+ 	      else
+ 		nstore[endp-startp] = 0;
+ #endif
  	      add_prefix (&startfile_prefixes, nstore, 0, 0, NULL_PTR);
  	      if (*endp == 0)
***************
*** 2482,2485 ****
--- 2539,2543 ----
  	    {
  	      strncpy (nstore, startp, endp-startp);
+ #ifndef __amigados__
  	      if (endp == startp)
  		strcpy (nstore, concat (".", dir_separator_str));
***************
*** 2491,2494 ****
--- 2549,2561 ----
  	      else
  		nstore[endp-startp] = 0;
+ #else
+ 	      if (endp[-1] != '/' && endp[-1] != ':')
+ 		{
+ 		  nstore[endp-startp] = '/';
+ 		  nstore[endp-startp+1] = 0;
+ 		}
+ 	      else
+ 		nstore[endp-startp] = 0;
+ #endif
  	      add_prefix (&startfile_prefixes, nstore, 0, 0, NULL_PTR);
  	      if (*endp == 0)
***************
*** 2510,2513 ****
--- 2577,2590 ----
    for (i = 1; i < argc; i++)
      {
+ #ifdef __amigados__
+       /* Phil.B 03-Oct-94 added -priority keyword */
+       if (! strcmp (argv[i], "-priority"))
+         {
+ 	  if (i + 1 == argc)
+ 	    fatal ("argument to `-priority' is missing");
+           amiga_priority = atoi(argv[++i]);
+         }
+       else
+ #endif /* __amigados__ */
        if (! strcmp (argv[i], "-dumpspecs"))
  	{
***************
*** 4483,4490 ****
--- 4560,4571 ----
  	  int len;
  
+ #ifdef FILE_NAME_NONDIRECTORY
+ 	  input_basename = FILE_NAME_NONDIRECTORY (input_filename);
+ #else
  	  input_basename = input_filename;
  	  for (p = input_filename; *p; p++)
  	    if (*p == '/' || *p == DIR_SEPARATOR)
  	      input_basename = p + 1;
+ #endif
  
  	  /* Find a suffix starting with the last period,
diff -2rcN /usr/goinfre/gcc-2.7.0/genconfig.c gcc-2.7.0-amiga/genconfig.c
*** /usr/goinfre/gcc-2.7.0/genconfig.c	Thu Jun 15 12:40:18 1995
--- gcc-2.7.0-amiga/genconfig.c	Fri Jun 23 11:52:29 1995
***************
*** 305,310 ****
--- 305,318 ----
  from the machine description file `md'.  */\n\n");
  
+ #ifdef __amigados__
+   /* this constant probably better be 14 in general, or a cross compiling
+      host might choke on some amigados header files... */
+ 
+   /* Allow at least 14 operands for the sake of asm constructs.  */
+   max_recog_operands = 14;
+ #else
    /* Allow at least 10 operands for the sake of asm constructs.  */
    max_recog_operands = 9;  /* We will add 1 later.  */
+ #endif
    max_dup_operands = 1;
  
diff -2rcN /usr/goinfre/gcc-2.7.0/ginclude/stdarg.h gcc-2.7.0-amiga/ginclude/stdarg.h
*** /usr/goinfre/gcc-2.7.0/ginclude/stdarg.h	Sun Apr 30 13:10:28 1995
--- gcc-2.7.0-amiga/ginclude/stdarg.h	Fri Jun 23 11:52:29 1995
***************
*** 168,170 ****
--- 168,178 ----
  
  #endif /* not _ANSI_STDARG_H_ */
+ 
+ #ifdef __amigados__
+ # ifndef _VA_LIST
+ #  define _VA_LIST
+    typedef __gnuc_va_list va_list;
+ # endif
+ #endif /* __amigados__ */
+ 
  #endif /* not _STDARG_H */
diff -2rcN /usr/goinfre/gcc-2.7.0/ginclude/stddef.h gcc-2.7.0-amiga/ginclude/stddef.h
*** /usr/goinfre/gcc-2.7.0/ginclude/stddef.h	Wed May 31 00:02:59 1995
--- gcc-2.7.0-amiga/ginclude/stddef.h	Fri Jun 23 11:52:29 1995
***************
*** 4,7 ****
--- 4,47 ----
  #ifndef __STDDEF_H__
  
+ #ifdef __amigados__
+ 
+ /* GNU libc has special support in this file, 4.3bsd-net2 libc deserves that
+    just as well. The system headers are ANSI compliant, the used compiler IS
+    gcc, so it's really ok to use the system header, no reason to hassle
+    with a jungle of ifdefs. Besides, amigados is only defined if compiling
+    with host=amigados, it doesn't apply if compiling with target=amigados
+    on a different host with possibly different system headers. Same thing
+    would apply to gstdarg.h and gvarargs.h, but those headers are more
+    easily fixable than this one and I'm sick of writing the same comment
+    there as well. MW
+ 
+    Include the contents of <stddef.h> inline rather than with a #include,
+    to avoid infinite include recursion when this file is installed in
+    gcc's include directory as stddef.h.  (fnf)  */
+ 
+ #define _STDDEF_H_
+ 
+ #include <machine/ansi.h>
+ 
+ typedef	_PTRDIFF_T_	ptrdiff_t;
+ 
+ #ifdef	_SIZE_T_
+ typedef	_SIZE_T_	size_t;
+ #undef	_SIZE_T_
+ #endif
+ 
+ #ifdef	_WCHAR_T_
+ typedef	_WCHAR_T_	wchar_t;
+ #undef	_WCHAR_T_
+ #endif
+ 
+ #ifndef	NULL
+ #define	NULL	0
+ #endif
+ 
+ #define	offsetof(type, member)	((size_t)(&((type *)0)->member))
+ 
+ #else /* not __amigados__ */
+ 
  /* Any one of these symbols __need_* means that GNU libc
     wants us just to define one data type.  So don't define
***************
*** 238,241 ****
--- 278,283 ----
  #define __WCHAR_TYPE__ int
  #endif
+ 
+ #endif /* not  __amigados__ */
  typedef __WCHAR_TYPE__ wchar_t;
  #endif
diff -2rcN /usr/goinfre/gcc-2.7.0/protoize.c gcc-2.7.0-amiga/protoize.c
*** /usr/goinfre/gcc-2.7.0/protoize.c	Thu Jun 15 12:57:09 1995
--- gcc-2.7.0-amiga/protoize.c	Fri Jun 23 11:52:30 1995
***************
*** 884,889 ****
--- 884,894 ----
    struct default_include *p;
  
+ #ifdef FILE_NAME_ABSOLUTE_P
+   if (! FILE_NAME_ABSOLUTE_P (path))
+     abort ();
+ #else
    if (path[0] != '/')
      abort ();		/* Must be an absolutized filename.  */
+ #endif
  
    for (p = include_defaults; p->fname; p++)
***************
*** 1312,1316 ****
--- 1317,1325 ----
      const char *src_p;
  
+ #ifdef FILE_NAME_ABSOLUTE_P
+     if (! FILE_NAME_ABSOLUTE_P (rel_filename))
+ #else
      if (rel_filename[0] != '/')
+ #endif
        {
          src_p = cwd2;
***************
*** 1575,1578 ****
--- 1584,1606 ----
  }
  
+ /* Use this macro to advance a char * over the filename part in a line
+    read from an aux-info file. */
+ 
+ #ifndef __amigados__
+ /* Version for file systems where the colon has no special meaning */
+ #define ADVANCE_PAST_FILENAME(CP) \
+   while (* (CP) != ':') (CP)++
+ #else
+ /* Have to heuristically decide whether the colon is part of the filename
+    or whether it serves to delimit the filename from the line number. If
+    it's the latter case, then the character following the colon *must*
+    be a digit. Note that this heuristic fails if the filename starts
+    with a digit. */
+ #define ADVANCE_PAST_FILENAME(CP) \
+     while ((CP)[0] != ':' || !isdigit ((CP)[1])) \
+       (CP)++;
+ #endif
+ 
+ 
  /* Given a line from  an aux info file, and a time at which the aux info
     file it came from was created, check to see if the item described in
***************
*** 1596,1601 ****
      const char *filename_start = p = l + 3;
  
!     while (*p != ':')
!       p++;
      filename = (char *) alloca ((size_t) (p - filename_start) + 1);
      strncpy (filename, filename_start, (size_t) (p - filename_start));
--- 1624,1628 ----
      const char *filename_start = p = l + 3;
  
!     ADVANCE_PAST_FILENAME (p);
      filename = (char *) alloca ((size_t) (p - filename_start) + 1);
      strncpy (filename, filename_start, (size_t) (p - filename_start));
***************
*** 1654,1659 ****
      char *filename;
  
!     while (*p != ':')
!       p++;
      filename = (char *) alloca ((size_t) (p - filename_start) + 1);
      strncpy (filename, filename_start, (size_t) (p - filename_start));
--- 1681,1685 ----
      char *filename;
  
!     ADVANCE_PAST_FILENAME (p);
      filename = (char *) alloca ((size_t) (p - filename_start) + 1);
      strncpy (filename, filename_start, (size_t) (p - filename_start));
***************
*** 2382,2386 ****
      char *p = aux_info_base;
  
!     while (*p != ':')
        p++;
      p++;
--- 2408,2414 ----
      char *p = aux_info_base;
  
!     /* have to make sure at least one space is following the colon to make
!        sure the colon is not part of the filename */
!     while (*p != ':' && p[1] != ' ')
        p++;
      p++;
***************
*** 2396,2400 ****
      aux_info_second_line = p;
      aux_info_relocated_name = 0;
!     if (invocation_filename[0] != '/')
        {
  	/* INVOCATION_FILENAME is relative;
--- 2424,2432 ----
      aux_info_second_line = p;
      aux_info_relocated_name = 0;
! #ifdef FILE_NAME_ABSOLUTE_P
!     if (! FILE_NAME_ABSOLUTE_P (invocation_filename))
! #else
!       if (invocation_filename[0] != '/')
! #endif
        {
  	/* INVOCATION_FILENAME is relative;
***************
*** 2485,2489 ****
  
  /* Check an individual filename for a .c suffix.  If the filename has this
!    suffix, rename the file such that its suffix is changed to .C.  This
     function implements the -C option.  */
  
--- 2517,2521 ----
  
  /* Check an individual filename for a .c suffix.  If the filename has this
!    suffix, rename the file such that its suffix is changed to .cc.  This
     function implements the -C option.  */
  
***************
*** 2494,2498 ****
    const char *filename = hp->symbol;
    int last_char_index = strlen (filename) - 1;
!   char *const new_filename = (char *) alloca (strlen (filename) + 1);
  
    /* Note that we don't care here if the given file was converted or not.  It
--- 2526,2530 ----
    const char *filename = hp->symbol;
    int last_char_index = strlen (filename) - 1;
!   char *const new_filename = (char *) alloca (strlen (filename) + 2);
  
    /* Note that we don't care here if the given file was converted or not.  It
***************
*** 2506,2511 ****
  
    strcpy (new_filename, filename);
!   new_filename[last_char_index] = 'C';
  
    if (my_link (filename, new_filename) == -1)
      {
--- 2538,2560 ----
  
    strcpy (new_filename, filename);
!   strcat (new_filename + last_char_index, "cc");
!   
!   /* use rename(2) if available !! Update config files to include HAVE_rename
!      if the used OS provides it. Advantages are: it's atomic, it's one
!      system call compared to two. */
  
+ #ifdef HAVE_rename
+   /* if the mentioned systems (POSIX 1003.1-1988) have rename(2), this has
+      to be changed to `my_rename' as well. */
+ 
+   if (rename (filename, new_filename) == -1)
+     {
+       fprintf (stderr, "%s: warning: can't rename file `%s' to `%s': %s\n",
+ 	       pname, shortpath (NULL, filename),
+ 	       shortpath (NULL, new_filename), my_strerror(errno));
+       errors++;
+       return;
+     }
+ #else
    if (my_link (filename, new_filename) == -1)
      {
***************
*** 2524,2527 ****
--- 2573,2577 ----
        return;
      }
+ #endif
  }
  
diff -2rcN /usr/goinfre/gcc-2.7.0/real.c gcc-2.7.0-amiga/real.c
*** /usr/goinfre/gcc-2.7.0/real.c	Thu Jun 15 12:57:39 1995
--- gcc-2.7.0-amiga/real.c	Fri Jun 23 11:52:31 1995
***************
*** 4422,4428 ****
--- 4422,4434 ----
      {
        if (sign)
+ #ifdef __amigados__
  	sprintf (wstring, " -Infinity ");
        else
  	sprintf (wstring, " Infinity ");
+ #else
+ 	sprintf (wstring, " -NaN ");
+       else
+ 	sprintf (wstring, " NaN ");
+ #endif
        goto bxit;
      }
diff -2rcN /usr/goinfre/gcc-2.7.0/rtl.def gcc-2.7.0-amiga/rtl.def
*** /usr/goinfre/gcc-2.7.0/rtl.def	Thu Jun 15 13:03:32 1995
--- gcc-2.7.0-amiga/rtl.def	Fri Jun 23 11:52:32 1995
***************
*** 705,710 ****
--- 705,712 ----
  DEF_RTL_EXPR(FLOAT_TRUNCATE, "float_truncate", "e", '1')
  
+ #ifndef SUPPRESS_RTL_FLOAT_DEFINITION	/* Amiga hack - avoid clash with <exec/types.h> typedef */
  /* Conversion of fixed point operand to floating point value.  */
  DEF_RTL_EXPR(FLOAT, "float", "e", '1')
+ #endif
  
  /* With fixed-point machine mode:
diff -2rcN /usr/goinfre/gcc-2.7.0/scan-types.sh gcc-2.7.0-amiga/scan-types.sh
*** /usr/goinfre/gcc-2.7.0/scan-types.sh	Mon Apr 18 08:07:12 1994
--- gcc-2.7.0-amiga/scan-types.sh	Fri Jun 23 11:52:33 1995
***************
*** 1,3 ****
! #! /bin/sh
  # Deduce values of standard ANSI and POSIX types (e.g. size_t, pid_t).
  # Emits macros definitions for these, and some other types.
--- 1,3 ----
! #!/bin/sh
  # Deduce values of standard ANSI and POSIX types (e.g. size_t, pid_t).
  # Emits macros definitions for these, and some other types.
diff -2rcN /usr/goinfre/gcc-2.7.0/toplev.c gcc-2.7.0-amiga/toplev.c
*** /usr/goinfre/gcc-2.7.0/toplev.c	Thu Jun 15 13:09:51 1995
--- gcc-2.7.0-amiga/toplev.c	Sun Jun 25 15:45:16 1995
***************
*** 56,59 ****
--- 56,62 ----
  #include "input.h"
  #include "tree.h"
+ #ifdef __amigados__
+ #define SUPPRESS_RTL_FLOAT_DEFINITION	/* Avoid <exec/types.h> and rtl.def typedef clash for "float" */
+ #endif
  #include "rtl.h"
  #include "flags.h"
***************
*** 142,145 ****
--- 145,156 ----
  static char *decl_name ();
  
+ #ifdef __amigados__
+ /* Phil.B: 03-Oct-94 Flag indicating process priority */
+ static int amiga_priority = -1;
+ static int amiga_old_priority;
+ #include <proto/exec.h>
+ struct Task *amiga_task;
+ #endif /* __amigados__ */
+ 
  /* Name of program invoked, sans directories.  */
  
***************
*** 540,543 ****
--- 551,555 ----
    {"writable-strings", &flag_writable_strings, 1},
    {"peephole", &flag_no_peephole, 0},
+   {"large-baserel", &flag_pic, 4},
    {"force-mem", &flag_force_mem, 1},
    {"force-addr", &flag_force_addr, 1},
***************
*** 558,561 ****
--- 570,574 ----
    {"pic", &flag_pic, 1},
    {"PIC", &flag_pic, 2},
+   {"baserel", &flag_pic, 3},
    {"fast-math", &flag_fast_math, 1},
    {"common", &flag_no_common, 0},
***************
*** 1361,1364 ****
--- 1374,1382 ----
    va_list ap;
  
+ /* PhB 25-Jun-95: restore old process priority before exiting */
+ #ifdef __amigados__
+   SetTaskPri(amiga_task, amiga_old_priority);
+ #endif /* __amigados__ */
+ 
    VA_START (ap, s);
  
***************
*** 1918,1921 ****
--- 1936,1942 ----
       char *input_name;
  {
+ #ifdef FILE_NAME_NONDIRECTORY
+   char *na = FILE_NAME_NONDIRECTORY (input_name);
+ #else
    int len = strlen (input_name);
    char *na = input_name + len;
***************
*** 1928,1931 ****
--- 1949,1953 ----
        na--;
      }
+ #endif
  
  #ifdef ASM_OUTPUT_MAIN_SOURCE_FILENAME
***************
*** 3320,3323 ****
--- 3342,3348 ----
  	 && p[-1] != DIR_SEPARATOR
  #endif
+ #ifdef VOL_SEPARATOR
+ 	 && p[-1] != VOL_SEPARATOR
+ #endif
  	 )
      --p;
***************
*** 3336,3339 ****
--- 3361,3373 ----
  #endif /* RLIMIT_STACK */
  
+ #ifdef __amigados__
+   {
+     char *envstr;
+ 
+     if (envstr = getenv("GCCPRIORITY"))
+       if (((i = atoi(envstr)) > -20) && (i < 20)) amiga_priority = i;
+   }
+ #endif /* __amigados__ */
+ 
    signal (SIGFPE, float_signal);
  
***************
*** 3581,3584 ****
--- 3615,3631 ----
  	  else if (!strcmp (str, "pedantic-errors"))
  	    flag_pedantic_errors = pedantic = 1;
+ #ifdef __amigados__
+ 	  else if (!strcmp (str, "priority"))
+ 	    {
+ 	      char *p = str + 1;
+ 
+ 	      if (*p)
+ 		amiga_priority = atoi (p);
+               if (amiga_priority < -25)
+ 	        amiga_priority = -25;
+               else if (amiga_priority > 25)
+ 	        amiga_priority = 25;
+ 	    }
+ #endif /* __amigados__ */
  	  else if (!strcmp (str, "quiet"))
  	    quiet_flag = 1;
***************
*** 3830,3833 ****
--- 3877,3887 ----
      }
  
+ #ifdef __amigados__
+   Forbid();
+   amiga_task = FindTask(NULL);
+   Permit();
+   amiga_old_priority = SetTaskPri(amiga_task, amiga_priority);
+ #endif /* __amigados__ */
+ 
    /* Initialize for bytecode output.  A good idea to do this as soon as
       possible after the "-f" options have been parsed. */
***************
*** 3916,3920 ****
    compile_file (filename);
  
! #if !defined(OS2) && !defined(VMS) && !defined(_WIN32)
    if (flag_print_mem)
      {
--- 3970,3974 ----
    compile_file (filename);
  
! #if !defined(OS2) && !defined(VMS) && !defined(_WIN32) && !defined (__amigados__)
    if (flag_print_mem)
      {
***************
*** 3934,3938 ****
  #endif /* not USG */
      }
! #endif /* not OS2 and not VMS and not _WIN32 */
  
    if (errorcount)
--- 3988,3998 ----
  #endif /* not USG */
      }
! #endif /* not OS2 and not VMS and not _WIN32 and not __amigados__ */
! 
! /* PhB 25-Jun-95: restore old process priority before exiting */
! #ifdef __amigados__
!   SetTaskPri(amiga_task, amiga_old_priority);
! #endif /* __amigados__ */
! 
  
    if (errorcount)
